Index: /palm/trunk/SOURCE/chem_emissions_mod.f90
===================================================================
--- /palm/trunk/SOURCE/chem_emissions_mod.f90	(revision 3967)
+++ /palm/trunk/SOURCE/chem_emissions_mod.f90	(revision 3968)
@@ -27,4 +27,10 @@
 ! -----------------
 ! $Id$
+! - in subroutine chem_emissions_match replace all decision structures relating to
+!   mode_emis to emiss_lod
+! - in subroutine chem_check_parameters replace emt%nspec with emt%n_emiss_species
+! - spring cleaning (E.C. Chan)
+! 
+! 3885 2019-04-11 11:29:34Z kanani
 ! Changes related to global restructuring of location messages and introduction 
 ! of additional debug messages
@@ -36,10 +42,10 @@
 ! Removed unused variables from chem_emissions_mod
 ! 
-!3772 2019-02-28 15:51:57Z suehring 
+! 3772 2019-02-28 15:51:57Z suehring 
 ! - In case of parametrized emissions, assure that emissions are only on natural
 !   surfaces (i.e. streets) and not on urban surfaces. 
 ! - some unnecessary if clauses removed
 !
-!3685 2019 -01-21 01:02:11Z knoop
+! 3685 2019 -01-21 01:02:11Z knoop
 ! Some interface calls moved to module_interface + cleanup
 ! 
@@ -172,7 +178,5 @@
     REAL(wp), PARAMETER ::  r_cp    = 0.286_wp               !< R / cp (exponent for potential temperature)
 
-
     SAVE
-
 
 !    
@@ -196,6 +200,4 @@
        MODULE PROCEDURE chem_emissions_setup
     END INTERFACE chem_emissions_setup
-
-
     
     PUBLIC chem_emissions_init, chem_emissions_match, chem_emissions_setup
@@ -213,12 +215,14 @@
  SUBROUTINE chem_emissions_check_parameters
 
-
     IMPLICIT NONE
 
     TYPE(chem_emis_att_type) ::  emt
 
-    !
-    !-- Check Emission Species Number equal to number of passed names for the chemistry species: 
-    IF ( SIZE(emt%species_name) /= emt%nspec  )  THEN
+!
+!-- Check if species count matches the number of names
+!-- passed for the chemiscal species
+
+    IF  ( SIZE(emt%species_name) /= emt%n_emiss_species  )  THEN
+!    IF  ( SIZE(emt%species_name) /= emt%nspec  )  THEN
 
        message_string = 'Numbers of input emission species names and number of species'     //      &
@@ -227,398 +231,64 @@
             
     ENDIF
-    
 
  END SUBROUTINE chem_emissions_check_parameters
+
 
 !------------------------------------------------------------------------------!
 ! Description:
 ! ------------
-!> Matching the chemical species indices. The routine checks what are the indices of the emission input species 
-!> and the corresponding ones of the model species. The routine gives as output a vector containing the number 
-!> of common species: it is important to note that while the model species are distinct, their values could be 
-!> given to a single species in input: for example, in the case of NO2 and NO, values may be passed in input as
-!> NOx values.
+!> Matching the chemical species indices. The routine checks what are the
+!> indices of the emission input species and the corresponding ones of the
+!> model species. The routine gives as output a vector containing the number 
+!> of common species: it is important to note that while the model species
+!> are distinct, their values could be given to a single species in input.
+!> For example, in the case of NO2 and NO, values may be passed in input as
+!> NOX values.
 !------------------------------------------------------------------------------!
+
 SUBROUTINE chem_emissions_match( emt_att,len_index )   
 
 
-    INTEGER(iwp), INTENT(INOUT)             ::  len_index   !< Variable where to store the number of common species between the input dataset and the model species   
-
-    TYPE(chem_emis_att_type), INTENT(INOUT) ::  emt_att     !< Chemistry Emission Array containing information for all the input chemical emission species
-   
-    INTEGER(iwp) ::  ind_mod, ind_inp                       !< Parameters for cycling through chemical model and input species 
-    INTEGER(iwp) ::  nspec_emis_inp                         !< Variable where to store the number of the emission species in input
-    INTEGER(iwp) ::  ind_voc                                !< Indices to check whether a split for voc should be done
-    INTEGER(iwp) ::  ispec                                  !< index for cycle over effective number of emission species
-
-
-    IF ( debug_output )  CALL debug_message( 'chem_emissions_match', 'start' )
-
-    !
-    !-- Number of input emission species.
-    nspec_emis_inp=emt_att%nspec 
-
-    !
-    !-- Check the emission mode: DEFAULT, PRE-PROCESSED or PARAMETERIZED 
-    SELECT CASE( TRIM( mode_emis ) ) 
-
-       !
-       !-- PRE-PROCESSED mode
-       CASE ( "PRE-PROCESSED" )
+
+    INTEGER(iwp)  ::  ind_inp                    !< Parameters for cycling through chemical input species 
+    INTEGER(iwp)  ::  ind_mod                    !< Parameters for cycling through chemical model species 
+    INTEGER(iwp)  ::  ind_voc                    !< Indices to check whether a split for voc should be done
+    INTEGER(iwp)  ::  ispec                      !< index for cycle over effective number of emission species
+    INTEGER(iwp)  ::  nspec_emis_inp             !< Variable where to store # of emission species in input
+
+    INTEGER(iwp), INTENT(INOUT)  ::  len_index   !< number of common species between input dataset & model species
+
+    TYPE(chem_emis_att_type), INTENT(INOUT) ::  emt_att     !< Chemistry Emission Array (decl. netcdf_data_input.f90)
+
+
+    IF  ( debug_output )  CALL debug_message( 'chem_emissions_match', 'start' )
+
+!
+!-- Number of input emission species
+
+    nspec_emis_inp = emt_att%n_emiss_species
+!    nspec_emis_inp=emt_att%nspec 
+
+!
+!-- Check the emission LOD: 0 (PARAMETERIZED), 1 (DEFAULT), 2 (PRE-PROCESSED)
+!
+    SELECT CASE (emiss_lod)
+
+!
+!-- LOD 0 (PARAMETERIZED mode)
+
+       CASE (0)
 
           len_index = 0
-          len_index_voc = 0
-
-          IF ( nvar > 0 .AND. (nspec_emis_inp > 0) )  THEN
-             !
-             !-- Cycle over model species
-             DO ind_mod = 1,  nvar 
-                !
-                !-- Cycle over input species  
-                DO ind_inp = 1, nspec_emis_inp
-
-                   !
-                   !-- Check for VOC Species  
-                   IF ( TRIM( emt_att%species_name(ind_inp) ) == "VOC" )  THEN        
-                      DO ind_voc = 1, emt_att%nvoc
-             
-                         IF ( TRIM( emt_att%voc_name(ind_voc) ) == TRIM( spc_names(ind_mod) ) )  THEN
-                            len_index = len_index + 1
-                            len_index_voc = len_index_voc + 1
-                         ENDIF
-                      END DO
-                   ENDIF
-                   !
-                   !-- Other Species
-                   IF ( TRIM( emt_att%species_name(ind_inp) ) == TRIM( spc_names(ind_mod) ) )  THEN
-                      len_index = len_index + 1
-                   ENDIF
-                ENDDO
-             ENDDO
-
-             !
-             !-- Allocate array for storing the indices of the matched species
-             IF ( len_index > 0 )  THEN
- 
-                ALLOCATE( match_spec_input(len_index) ) 
- 
-                ALLOCATE( match_spec_model(len_index) )
-
-                IF ( len_index_voc > 0 )  THEN
-                   !
-                   !-- contains indices of the VOC model species
-                   ALLOCATE( match_spec_voc_model(len_index_voc) )
-                   !
-                   !-- contains the indices of different values of VOC composition of input variable VOC_composition
-                   ALLOCATE( match_spec_voc_input(len_index_voc) )
-
-                ENDIF
-
-                !
-                !-- pass the species indices to declared arrays
-                len_index = 0
-
-                !
-                !-- Cycle over model species
-                DO ind_mod = 1, nvar 
-                   !
-                   !-- Cycle over Input species  
-                   DO ind_inp = 1, nspec_emis_inp
-                      !
-                      !-- VOCs
-                      IF ( TRIM(emt_att%species_name(ind_inp) ) == "VOC" .AND.    &
-                           ALLOCATED(match_spec_voc_input) )  THEN
-                         
-                         DO ind_voc= 1, emt_att%nvoc
-                            IF ( TRIM( emt_att%voc_name(ind_voc) ) == TRIM( spc_names(ind_mod) ) )  THEN
-                               len_index = len_index + 1
-                               len_index_voc = len_index_voc + 1
-                        
-                               match_spec_input(len_index) = ind_inp
-                               match_spec_model(len_index) = ind_mod
-
-                               match_spec_voc_input(len_index_voc) = ind_voc
-                               match_spec_voc_model(len_index_voc) = ind_mod                         
-                            ENDIF
-                         END DO
-                      ENDIF
-
-                      !
-                      !-- Other Species
-                      IF ( TRIM( emt_att%species_name(ind_inp) ) == TRIM( spc_names(ind_mod) ) )  THEN
-                         len_index = len_index + 1
-                         match_spec_input(len_index) = ind_inp
-                         match_spec_model(len_index) = ind_mod
-                      ENDIF
-                   END DO
-                END DO
-
-             ELSE
-                !
-                !-- in case there are no species matching
-                message_string = 'Non of given emission species'            //         &
-                                 ' matches'                                //          &
-                                 ' model chemical species:'                //          &
-                                 ' Emission routine is not called'  
-                CALL message( 'chem_emissions_matching', 'CM0438', 0, 0, 0, 6, 0 )
-             ENDIF
- 
-          ELSE
-
-             !
-             !-- either spc_names is zero or nspec_emis_inp is not allocated
-             message_string = 'Array of Emission species not allocated:'             //          &
-                              ' Either no emission species are provided as input or'  //         &
-                              ' no chemical species are used by PALM:'                //         &
-                              ' Emission routine is not called'                  
-             CALL message( 'chem_emissions_matching', 'CM0439', 0, 2, 0, 6, 0 ) 
-
-          ENDIF
-
-       !
-       !-- DEFAULT mode
-       CASE ("DEFAULT")
-
-          len_index = 0          !<  index for TOTAL number of species   
-          len_index_voc = 0      !<  index for TOTAL number of VOCs
-          len_index_pm = 3       !<  index for TOTAL number of PMs: PM1, PM2.5, PM10.
- 
-          IF ( nvar > 0 .AND. nspec_emis_inp > 0 )  THEN
-
-             !
-             !-- Cycle over model species
-             DO ind_mod = 1, nvar
-                !
-                !-- Cycle over input species
-                DO ind_inp = 1, nspec_emis_inp
-
-                   !
-                   !-- Check for VOC Species  
-                   IF ( TRIM( emt_att%species_name(ind_inp) ) == "VOC" )  THEN
-                      DO ind_voc= 1, emt_att%nvoc
-                        
-                         IF ( TRIM( emt_att%voc_name(ind_voc) ) == TRIM( spc_names(ind_mod) ) )  THEN
-                            len_index = len_index + 1
-                            len_index_voc = len_index_voc + 1
-                         ENDIF
-                         
-                      END DO
-                   ENDIF
-
-                   !
-                   !-- PMs: There is one input species name for all PM 
-                   !-- This variable has 3 dimensions, one for PM1, PM2.5 and PM10
-                   IF ( TRIM( emt_att%species_name(ind_inp) ) == "PM" )  THEN
-                      !
-                      !-- PM1
-                      IF ( TRIM( spc_names(ind_mod) ) == "PM1" )  THEN
-                         len_index = len_index + 1
-                      !
-                      !-- PM2.5
-                      ELSEIF ( TRIM( spc_names(ind_mod) ) == "PM25" )  THEN
-                         len_index = len_index + 1
-                      !
-                      !-- PM10
-                      ELSEIF ( TRIM( spc_names(ind_mod) ) == "PM10" )  THEN
-                         len_index = len_index + 1
-                      ENDIF
-                   ENDIF
-
-                   !
-                   !-- NOx: NO2 and NO    
-                   IF ( TRIM( emt_att%species_name(ind_inp) ) == "NOx" )  THEN 
-                      !
-                      !-- NO
-                      IF ( TRIM( spc_names(ind_mod) ) == "NO" )  THEN
-                         len_index = len_index + 1
-                      !
-                      !-- NO2
-                      ELSEIF ( TRIM( spc_names(ind_mod) ) == "NO2" )  THEN
-                         len_index = len_index + 1
-                      ENDIF
-                   ENDIF
-
-                   !
-                   !-- SOx: SO2 and SO4
-                   IF ( TRIM( emt_att%species_name(ind_inp) ) == "SOx" )  THEN
-                      !
-                      !-- SO2
-                      IF ( TRIM( spc_names(ind_mod) ) == "SO2" )  THEN
-                         len_index = len_index + 1
-                      !
-                      !-- SO4
-                      ELSEIF ( TRIM( spc_names(ind_mod) ) == "SO4" )  THEN
-                         len_index = len_index + 1
-                      ENDIF
-                   ENDIF
-
-                   !
-                   !-- Other Species
-                   IF ( TRIM( emt_att%species_name(ind_inp) ) == TRIM( spc_names(ind_mod) ) )  THEN
-                      len_index = len_index + 1
-                   ENDIF
-                END DO
-             END DO
-
-
-             !
-             !-- Allocate arrays
-             IF ( len_index > 0 )  THEN
-
-                ALLOCATE( match_spec_input(len_index) )
-                ALLOCATE( match_spec_model(len_index) )
-
-                IF ( len_index_voc > 0 )  THEN
-                   !
-                   !-- Contains indices of the VOC model species
-                   ALLOCATE( match_spec_voc_model(len_index_voc) )
-                   !
-                   !-- Contains the indices of different values of VOC composition
-                   !-- of input variable VOC_composition
-                   ALLOCATE( match_spec_voc_input(len_index_voc) )                                                  
-                ENDIF
-
-                !
-                !-- Pass the species indices to declared arrays
-                len_index = 0
-                len_index_voc = 0
-                
-                DO ind_mod = 1, nvar
-                   DO ind_inp = 1, nspec_emis_inp 
-
-                      !
-                      !-- VOCs
-                      IF ( TRIM( emt_att%species_name(ind_inp) ) == "VOC" .AND.   &
-                         ALLOCATED(match_spec_voc_input) )  THEN      
-                         DO ind_voc= 1, emt_att%nvoc
-                            IF ( TRIM( emt_att%voc_name(ind_voc) ) == TRIM( spc_names(ind_mod) ) )  THEN
-                               len_index = len_index + 1
-                               len_index_voc = len_index_voc + 1
-                        
-                               match_spec_input(len_index) = ind_inp
-                               match_spec_model(len_index) = ind_mod
-
-                               match_spec_voc_input(len_index_voc) = ind_voc
-                               match_spec_voc_model(len_index_voc) = ind_mod                         
-                            ENDIF
-                         END DO
-                      ENDIF
-
-                      !
-                      !-- PMs 
-                      IF ( TRIM( emt_att%species_name(ind_inp) ) == "PM" )  THEN
-                         !
-                         !-- PM1
-                         IF ( TRIM( spc_names(ind_mod) ) == "PM1" )  THEN
-                            len_index = len_index + 1
-
-                            match_spec_input(len_index) = ind_inp
-                            match_spec_model(len_index) = ind_mod
-                         !
-                         !-- PM2.5
-                         ELSEIF ( TRIM( spc_names(ind_mod) ) == "PM25" )  THEN
-                            len_index = len_index + 1
-
-                            match_spec_input(len_index) = ind_inp
-                            match_spec_model(len_index) = ind_mod
-                         !
-                         !-- PM10
-                         ELSEIF ( TRIM( spc_names(ind_mod) ) == "PM10" )  THEN
-                            len_index = len_index + 1
-    
-                            match_spec_input(len_index) = ind_inp
-                            match_spec_model(len_index) = ind_mod
-  
-                         ENDIF
-                      ENDIF
-
-                      !
-                      !-- NOx 
-                      IF ( TRIM( emt_att%species_name(ind_inp) ) == "NOx" )  THEN
-                         !
-                         !-- NO
-                         IF ( TRIM( spc_names(ind_mod) ) == "NO" )  THEN
-                            len_index = len_index + 1
-
-                            match_spec_input(len_index) = ind_inp
-                            match_spec_model(len_index) = ind_mod
-                         !
-                         !-- NO2
-                         ELSEIF ( TRIM( spc_names(ind_mod) ) == "NO2" )  THEN
-                            len_index = len_index + 1
-
-                            match_spec_input(len_index) = ind_inp
-                            match_spec_model(len_index) = ind_mod
-  
-                         ENDIF
-                      ENDIF
-
-                      !
-                      !-- SOx 
-                      IF ( TRIM( emt_att%species_name(ind_inp) ) == "SOx" ) THEN
-                         !
-                         !-- SO2
-                         IF ( TRIM( spc_names(ind_mod) ) == "SO2" )  THEN
-                            len_index = len_index + 1
-
-                            match_spec_input(len_index) = ind_inp
-                            match_spec_model(len_index) = ind_mod
-  
-                         !
-                         !-- SO4
-                         ELSEIF ( TRIM( spc_names(ind_mod) ) == "SO4" )  THEN
-                            len_index = len_index + 1
-
-                            match_spec_input(len_index) = ind_inp
-                            match_spec_model(len_index) = ind_mod
-  
-                         ENDIF
-                      ENDIF
-
-                      !
-                      !-- Other Species
-                      IF ( TRIM( emt_att%species_name(ind_inp) ) == TRIM( spc_names(ind_mod) ) )  THEN
-                         len_index = len_index + 1
-                            
-                         match_spec_input(len_index) = ind_inp
-                         match_spec_model(len_index) = ind_mod
-                      ENDIF
-                   END DO
-                END DO
-
-             ELSE
-
-                message_string = 'Non of given Emission Species'            //         &
-                                 ' matches'                                //          &
-                                 ' model chemical species'                 //          &
-                                 ' Emission routine is not called'         
-                CALL message( 'chem_emissions_matching', 'CM0440', 0, 0, 0, 6, 0 ) 
-
-             ENDIF
-
-          ELSE
-
-             message_string = 'Array of Emission species not allocated: '            //          &
-                              ' Either no emission species are provided as input or'  //         &
-                              ' no chemical species are used by PALM:'                //         &
-                              ' Emission routine is not called'                                   
-             CALL message( 'chem_emissions_matching', 'CM0441', 0, 2, 0, 6, 0 ) 
- 
-          ENDIF
- 
-       !
-       !-- PARAMETERIZED mode
-       CASE ("PARAMETERIZED")
-
-          len_index = 0
-
-          IF ( nvar > 0 .AND. nspec_emis_inp > 0 )  THEN
-
-             !
-             !-- Cycle over model species
+
+          IF  ( nvar > 0 .AND. nspec_emis_inp > 0 )  THEN
+
+!
+!-- Cycle over model species
+
              DO ind_mod = 1, nvar
                 ind_inp = 1
                 DO WHILE ( TRIM( surface_csflux_name(ind_inp) ) /= 'novalue' )    !< 'novalue' is the default  
-                   IF ( TRIM( surface_csflux_name(ind_inp) ) == TRIM( spc_names(ind_mod) ) )  THEN
+                   IF  ( TRIM( surface_csflux_name(ind_inp) ) == TRIM( spc_names(ind_mod) ) )  THEN
                       len_index = len_index + 1
                    ENDIF
@@ -627,20 +297,22 @@
              ENDDO
 
-             IF ( len_index > 0 )  THEN
-
-                !
-                !-- Allocation of Arrays of the matched species
-                ALLOCATE( match_spec_input(len_index) ) 
- 
-                ALLOCATE( match_spec_model(len_index) )
-
-                !
-                !-- Pass the species indices to declared arrays    
+             IF  ( len_index > 0 )  THEN
+
+!
+!-- Allocation of Arrays of the matched species
+
+                ALLOCATE ( match_spec_input(len_index) ) 
+                ALLOCATE ( match_spec_model(len_index) )
+
+!
+!-- Pass species indices to declared arrays
+
                 len_index = 0
 
                 DO ind_mod = 1, nvar  
                    ind_inp = 1
-                   DO WHILE ( TRIM( surface_csflux_name(ind_inp) ) /= 'novalue' )     
-                      IF ( TRIM( surface_csflux_name(ind_inp) ) == TRIM( spc_names(ind_mod) ) )  THEN
+                   DO WHILE  ( TRIM( surface_csflux_name(ind_inp) ) /= 'novalue' )
+                      IF  ( TRIM(surface_csflux_name(ind_inp)) ==          &
+                            TRIM(spc_names(ind_mod))            )  THEN
                          len_index = len_index + 1
                          match_spec_input(len_index) = ind_inp
@@ -651,12 +323,13 @@
                 END DO
 
-                !
-                !-- Check
+!
+!-- Check
+
                 DO ispec = 1, len_index
 
-                   IF ( emiss_factor_main(match_spec_input(ispec) ) < 0 .AND.    &
+                   IF  ( emiss_factor_main(match_spec_input(ispec) ) < 0 .AND.    &
                         emiss_factor_side(match_spec_input(ispec) ) < 0 )  THEN
 
-                      message_string = 'PARAMETERIZED emissions mode selected:'            //           &
+                      message_string = 'PARAMETERIZED emissions mode selected:'             //          &
                                        ' EMISSIONS POSSIBLE ONLY ON STREET SURFACES'        //          &
                                        ' but values of scaling factors for street types'    //          &
@@ -665,6 +338,8 @@
                                        ' or not provided at all: PLEASE set a finite value' //          &
                                        ' for these parameters in the chemistry namelist'          
-                      CALL message( 'chem_emissions_matching', 'CM0442', 2, 2, 0, 6, 0 ) 
+                      CALL message( 'chem_emissions_matching', 'CM0442', 2, 2, 0, 6, 0 )
+ 
                    ENDIF
+
                 END DO
 
@@ -672,14 +347,15 @@
              ELSE
                 
-                message_string = 'Non of given Emission Species'            //          &
+                message_string = 'Non of given Emission Species'           //           &
                                  ' matches'                                //           &
                                  ' model chemical species'                 //           &
                                  ' Emission routine is not called'         
-                CALL message( 'chem_emissions_matching', 'CM0443', 0, 0, 0, 6, 0 ) 
+                CALL message( 'chem_emissions_matching', 'CM0443', 0, 0, 0, 6, 0 )
+ 
              ENDIF
 
           ELSE
      
-             message_string = 'Array of Emission species not allocated: '            //           &
+             message_string = 'Array of Emission species not allocated: '             //          &
                               ' Either no emission species are provided as input or'  //          &
                               ' no chemical species are used by PALM.'                //          &
